Subject: Re: ip_gre headroom allocation

From: Timo Teräs <[email-masked]>
Date: Thu, 11 Jun 2009 13:17:14 +0300

David Miller wrote:
> From: Timo Teräs <[email-masked]>
> Date: Thu, 11 Jun 2009 11:22:34 +0300
> 
>> I'm not entirely sure about this, but shouldn't we do something like
>> the below to make ip_gre allocation enough headroom for paths where
>> e.g. xfrm transformations take place (as a speed optimization)?
> 
> This should be handled by the code one level up that allocates
> the SKB.
> 
> And as routes get stacked, the MTUs and headroom values get adjusted
> up to the root.
> 
> At least that's how it's supposed to work :-)

Ok, that makes sense. I was just wondering if there's any corner cases
were this would have helped.

> Otherwise we'd need a similar hack in ipip.c too.

I was under the impression that as we need to do the route lookup anyway
we could take advantage of the information available from there fully.

But yes, your explanation makes perfect sense.

Thanks,
  Timo